#if !defined( __DISPLAY_H__ )
#define __DISPLAY_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>

#include "generic.h"
#include "lcd.h"
#include "lcd_tools.h"
#include "i2c_lcd.h"

// --------------------------------------------------------------------------
// DEFINES                                                                   
// --------------------------------------------------------------------------

#define USE_I2C_LCD 1

#if defined( USE_I2C_LCD )

#define lcd_init   i2c_lcd_init
#define lcd_clrscr i2c_lcd_clrscr
#define lcd_home   i2c_lcd_home
#define lcd_gotoxy i2c_lcd_gotoxy
#define lcd_putc   i2c_lcd_putc
#define lcd_puts   i2c_lcd_puts
#define lcd_puts_p i2c_lcd_puts_p

#endif
  
// --------------------------------------------------------------------------
// Function prototypes
// --------------------------------------------------------------------------

  void clear_display_buffer( void );
  void clear_display_line( uint16_t );
  void clear_display( void );
  void display_line( uint8_t, const char * );
  void update_lcd( void );
  void clear_display_and_update_status( void );
  void update_status_display( void );
  rc_t format( FILE *, const char *, ... );
  void display_format_buffer( uint8_t, const char *, ... );  
  void display_format( uint8_t, const char *, ... );
  
#ifdef __cplusplus
} /* closing brace for extern "C" */
#endif

#endif
