#if !defined( __I2C_LCD_H__ )
#define __I2C_LCD_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include "lcd.h"

#if !defined( I2C_LCD_ADDRESS )
#define I2C_LCD_ADDRESS 0xc6
#endif

#define LCD_CMD_CURSOR_HOME                1
#define LCD_CMD_SET_CURSOR_PLACE           2
#define LCD_CMD_SET_CURSOR_XY              3
#define LCD_CMD_HIDE_CURSOR                4
#define LCD_CMD_SHOW_UNDERLINE_CURSOR      5
#define LCD_CMD_SHOW_BLINKING_CURSOR       6
#define LCD_CMD_BACKSPACE                  8
#define LCD_CMD_CLEAR_SCREEN              12
#define LCD_CMD_BACKLIGHT_ON              19
#define LCD_CMD_BACKLIGHT_OFF             20

#define LCD_MODE_HIDE_CURSOR           (1<<0)
#define LCD_MODE_UNDERLINE_CURSOR      (1<<1)
#define LCD_MODE_BLINK_CURSOR          (1<<2)
#define LCD_MODE_BACKLIGHT_ON          (1<<3)

#define I2C_LCD_MIN_FIFO_FREE_BYTES        2
#define I2C_LCD_MAX_WAIT_TICKS            50

#define I2C_LCD_REGISTER_0                 0
#define I2C_LCD_REGISTER_1                 1
#define I2C_LCD_REGISTER_2                 2
#define I2C_LCD_REGISTER_3                 3

  extern uint8_t i2c_lcd_read( uint8_t, uint8_t );
  extern rc_t    i2c_lcd_write( uint8_t, uint8_t, uint8_t );
  extern rc_t    i2c_lcd_send_command( uint8_t );

  extern rc_t    i2c_lcd_init( uint8_t, uint8_t );
  extern void    i2c_lcd_clrscr( void );
  extern void    i2c_lcd_home( void );
  extern void    i2c_lcd_gotoxy( uint8_t, uint8_t );
  extern void    i2c_lcd_putc( char );
  extern void    i2c_lcd_puts( const char * );
  extern void    i2c_lcd_puts_p(const char * );

#ifdef __cplusplus
} /* closing brace for extern "C" */
#endif

#endif
