#if !defined( __LCD_TOOLS_H__ )
#define __LCD_TOOLS_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <avr/io.h> 
#include <util/delay.h>
#include "lcd.h"

#define IS_VALID_LCD_LINE_NR(linenr) (( linenr > 0 ) && ( linenr <= LCD_LINES ))

extern void lcd_flash_e (void);
extern void lcd_write (uint8_t, uint8_t);
extern void lcd_cls (void);
extern void lcd_writechar (char);
extern void lcd_writetext (char *);
extern void lcd_gotoline (uint8_t);
extern void lcd_gotopos (uint8_t, uint8_t);
extern void lcd_writezahl (int32_t, uint8_t, uint8_t);
extern void lcd_set4bit (void);
extern void lcd_port_ini (void);
extern void lcd_ini (void);

extern void lcd_home( void );
extern void lcd_init( uint8_t );
extern void lcd_puts( const char * );
extern void lcd_putc( char );
extern void lcd_clrscr( void );

#ifdef __cplusplus
} /* closing brace for extern "C" */
#endif

#endif
